Index: trunk/ab5.0/abdev/abdev/Attach.cpp
===================================================================
--- trunk/ab5.0/abdev/abdev/Attach.cpp	(revision 825)
+++ trunk/ab5.0/abdev/abdev/Attach.cpp	(revision 828)
@@ -4,4 +4,6 @@
 
 #include "common.h"
+#include <abdev/ab_common/include/Path.h>
+#include <abdev/ab_common/include/ProcessAndModule.h>
 #include <psapi.h>
 #include <tlhelp32.h>
@@ -37,5 +39,5 @@
 }
 
-void InsertProcess_ToListView(HWND hListView,char *lpszAppPath,int id,char *lpszPlatform,char *lpszTitle){
+void InsertProcess_ToListView(HWND hListView,char const* lpszAppPath,int id,char const* lpszPlatform,char const * lpszTitle){
 	char szAppName[MAX_PATH],temp2[MAX_PATH];
 	_splitpath(lpszAppPath,NULL,NULL,szAppName,temp2);
@@ -75,9 +77,9 @@
 	ListView_SetItem(hListView,&item);
 
-	item.pszText=lpszPlatform;
+	item.pszText=const_cast<LPSTR>(lpszPlatform);
 	item.iSubItem++;
 	ListView_SetItem(hListView,&item);
 
-	item.pszText=lpszTitle;
+	item.pszText=const_cast<LPSTR>(lpszTitle);
 	item.iSubItem++;
 	ListView_SetItem(hListView,&item);
@@ -159,40 +161,30 @@
 BOOL CALLBACK FindWindowProc(HWND hwnd, LPARAM lParam)
 {
-    HWND* pphWnd = (HWND*)lParam;
-    *pphWnd = hwnd;
-    return FALSE; /* 列挙を中断 */
+	auto pProcessIdAndHWnd = reinterpret_cast<std::pair<DWORD, HWND>*>(lParam);
+	DWORD processId = 0;
+	::GetWindowThreadProcessId(hwnd, &processId);
+	if (processId == pProcessIdAndHWnd->first)
+	{
+		pProcessIdAndHWnd->second = hwnd;
+		return FALSE;
+	}
+	else
+	{
+		return TRUE;
+	}
 }
 void ListupProcesses(HWND hListView){
-	char temporary[MAX_PATH];
-
 	ListView_DeleteAllItems(hListView);
 
-	DWORD *pdwProcessId;
-	pdwProcessId=(DWORD *)HeapAlloc(hHeap,0,8192*sizeof(DWORD));
-
 	//プロセスを列挙
-	DWORD cbNeeded;
-	EnumProcesses(pdwProcessId,8192*sizeof(DWORD),&cbNeeded);
-
-	char szMyAppPath[MAX_PATH];
-	GetModuleFileName(GetModuleHandle(0),szMyAppPath,MAX_PATH);
-
-	int i;
-	for(i=0;i<(int)(cbNeeded/sizeof(DWORD));i++){
-
-		//プロセスIDを元にハンドルを取得
-		HANDLE hProcess;
-		hProcess=OpenProcess(PROCESS_ALL_ACCESS,0,pdwProcessId[i]);
-		if(!hProcess) continue;
-
+	auto processIds = ActiveBasic::Common::GetProcesses();
+
+	char szMyAppPath[MAX_PATH] = {};
+	GetModuleFileName(nullptr, szMyAppPath, MAX_PATH);
+
+	BOOST_FOREACH(DWORD processId, processIds)
+	{
 		//そのプロセスにおける実行モジュールのインスタンスハンドルを取得
-		HINSTANCE hModule;
-		DWORD cbReturned;
-		if(!EnumProcessModules( hProcess, &hModule, sizeof(HINSTANCE), &cbReturned ))
-			continue;
-
-		//実行ファイル名を取得
-		GetModuleFileNameEx(hProcess,hModule,temporary,MAX_PATH);
-
+		auto executablePath = ActiveBasic::Common::GetExecutableModulePath(processId);
 
 		//////////////////////////////
@@ -200,36 +192,13 @@
 		//////////////////////////////
 
-		//スナップショットを取得
-		HANDLE hSnapshot;
-		hSnapshot=CreateToolhelp32Snapshot(TH32CS_SNAPALL,0);
-
-		THREADENTRY32 te;
-		memset(&te,0,sizeof(THREADENTRY32));
-		te.dwSize=sizeof(THREADENTRY32);
-		if(Thread32First(hSnapshot,&te)){
-			do{
-				if(te.th32OwnerProcessID==pdwProcessId[i]){
-					break;
-				}
-			}while(Thread32Next(hSnapshot,&te));
-		}
-
-		HWND hwnd;
-		hwnd=0;
-		EnumThreadWindows(te.th32ThreadID,FindWindowProc,(LPARAM)&hwnd);
-
-		while(GetParent(hwnd)) hwnd=GetParent(hwnd);
-
-		char szWndTitle[1024];
-		szWndTitle[0]=0;
-		if(hwnd) GetWindowText(hwnd,szWndTitle,1024);
-
-		CloseHandle(hSnapshot);
-
-
-
-		CloseHandle(hProcess);
-
-		if(lstrcmpi(szMyAppPath,temporary)==0){
+		std::pair<DWORD, HWND> processIdAndHWnd(processId, nullptr);
+		EnumWindows(FindWindowProc, reinterpret_cast<LPARAM>(&processIdAndHWnd));
+		HWND hwnd = processIdAndHWnd.second;
+
+		TCHAR szWndTitle[1024] = {};
+		if(hwnd) GetWindowText(hwnd, szWndTitle, 1024);
+
+		if (ActiveBasic::Common::IsPathEqual(Jenga::Common::ToWString(szMyAppPath).c_str(), executablePath.wstring().c_str()))
+		{
 			//自分自身（ProjectEditor.exe）は無視
 			continue;
@@ -237,8 +206,6 @@
 
 		//リストビューへ追加
-		InsertProcess_ToListView(hListView,temporary,pdwProcessId[i],"Win32",szWndTitle);
-	}
-
-	HeapDefaultFree(pdwProcessId);
+		InsertProcess_ToListView(hListView,executablePath.string().c_str(),processId,"Win32",szWndTitle);
+	}
 }
 
Index: trunk/ab5.0/abdev/abdev/ChildWndOnRebar.cpp
===================================================================
--- trunk/ab5.0/abdev/abdev/ChildWndOnRebar.cpp	(revision 825)
+++ trunk/ab5.0/abdev/abdev/ChildWndOnRebar.cpp	(revision 828)
@@ -229,5 +229,5 @@
 
 
-#define ADD_TOOLBAR_BUTTON(id,iconID,lpszToolTip) pobj_StandardToolbar->Add(id,(HICON)LoadImage(hIconResInst,MAKEINTRESOURCE(iconID),IMAGE_ICON,16,16,0),lpszToolTip)
+#define ADD_TOOLBAR_BUTTON(id, iconID, lpszToolTip) pobj_StandardToolbar->Add((id), ActiveBasic::Resource::LoadIconAlt(hIconResInst, (iconID), 16, 16), (lpszToolTip))
 #define ADD_TOOLBAR_SEPARATOR pobj_StandardToolbar->Add(0,0,0)
 	//ボタン類を追加
@@ -279,5 +279,5 @@
 	pobj_DebuggerToolbar->Create(hDebuggerToolbarPager);
 
-#define ADD_TOOLBAR_BUTTON(id,iconID,lpszToolTip) pobj_DebuggerToolbar->Add(id,(HICON)LoadImage(hIconResInst,MAKEINTRESOURCE(iconID),IMAGE_ICON,16,16,0),lpszToolTip)
+#define ADD_TOOLBAR_BUTTON(id, iconID, lpszToolTip) pobj_DebuggerToolbar->Add((id), ActiveBasic::Resource::LoadIconAlt(hIconResInst, (iconID), 16, 16), (lpszToolTip))
 #define ADD_TOOLBAR_SEPARATOR pobj_DebuggerToolbar->Add(0,0,0)
 	//ボタン類を追加
@@ -327,5 +327,5 @@
 	pobj_ReleaseToolbar->Create(hReleaseToolbarPager);
 
-#define ADD_TOOLBAR_BUTTON(id,iconID,lpszToolTip) pobj_ReleaseToolbar->Add(id,(HICON)LoadImage(hIconResInst,MAKEINTRESOURCE(iconID),IMAGE_ICON,16,16,0),lpszToolTip)
+#define ADD_TOOLBAR_BUTTON(id, iconID, lpszToolTip) pobj_ReleaseToolbar->Add((id), ActiveBasic::Resource::LoadIconAlt(hIconResInst, (iconID), 16, 16), (lpszToolTip))
 #define ADD_TOOLBAR_SEPARATOR pobj_ReleaseToolbar->Add(0,0,0)
 	//ボタン類を追加
Index: trunk/ab5.0/abdev/abdev/Common.h
===================================================================
--- trunk/ab5.0/abdev/abdev/Common.h	(revision 825)
+++ trunk/ab5.0/abdev/abdev/Common.h	(revision 828)
@@ -33,4 +33,5 @@
 #include "Debugger.h"
 
+#include <Resource/Load.h>
 
 #pragma comment(lib, "wininet.lib")
@@ -627,5 +628,5 @@
 void GetFullPath(char *path,const char *dir);
 void RemoveDirectoryStrong(const char *dirPath);
-BOOL GetFilePathDialog(HWND hwnd,char *filename,LPSTR Filter,LPSTR Title,_int8 IsOpen);
+BOOL GetFilePathDialog(HWND hwnd,char *filename,LPCSTR Filter,LPCSTR Title,BOOL IsOpen);
 BOOL GetFolder(HWND hWnd,char *folder,char *OpenFolderTitle);
 int GetFileExtension( const char *path );
Index: trunk/ab5.0/abdev/abdev/Complement.cpp
===================================================================
--- trunk/ab5.0/abdev/abdev/Complement.cpp	(revision 825)
+++ trunk/ab5.0/abdev/abdev/Complement.cpp	(revision 828)
@@ -754,11 +754,11 @@
 			hImageList=ImageList_Create(16, 16, ILC_COLOR24, 7, 0);
 			ListView_SetImageList(hListView, hImageList, LVSIL_SMALL);
-			ImageList_AddIcon(hImageList, LoadIcon(hResInst, MAKEINTRESOURCE(IDI_MEMBER_PRIVATE_VARIABLE)));
-			ImageList_AddIcon(hImageList, LoadIcon(hResInst, MAKEINTRESOURCE(IDI_MEMBER_PUBLIC_VARIABLE)));
-			ImageList_AddIcon(hImageList, LoadIcon(hResInst, MAKEINTRESOURCE(IDI_MEMBER_PRIVATE_FUNCTION)));
-			ImageList_AddIcon(hImageList, LoadIcon(hResInst, MAKEINTRESOURCE(IDI_MEMBER_PUBLIC_FUNCTION)));
-			ImageList_AddIcon(hImageList, LoadIcon(hResInst, MAKEINTRESOURCE(IDI_PAIRSTATEMENT)));
-			ImageList_AddIcon(hImageList, LoadIcon(hResInst, MAKEINTRESOURCE(IDI_HTML_GENERAL_PARAMETER)));
-			ImageList_AddIcon(hImageList, LoadIcon(hResInst, MAKEINTRESOURCE(IDI_HTML_PARAMETER)));
+			ImageList_AddIcon(hImageList, ActiveBasic::Resource::LoadIconAlt(hResInst, IDI_MEMBER_PRIVATE_VARIABLE));
+			ImageList_AddIcon(hImageList, ActiveBasic::Resource::LoadIconAlt(hResInst, IDI_MEMBER_PUBLIC_VARIABLE));
+			ImageList_AddIcon(hImageList, ActiveBasic::Resource::LoadIconAlt(hResInst, IDI_MEMBER_PRIVATE_FUNCTION));
+			ImageList_AddIcon(hImageList, ActiveBasic::Resource::LoadIconAlt(hResInst, IDI_MEMBER_PUBLIC_FUNCTION));
+			ImageList_AddIcon(hImageList, ActiveBasic::Resource::LoadIconAlt(hResInst, IDI_PAIRSTATEMENT));
+			ImageList_AddIcon(hImageList, ActiveBasic::Resource::LoadIconAlt(hResInst, IDI_HTML_GENERAL_PARAMETER));
+			ImageList_AddIcon(hImageList, ActiveBasic::Resource::LoadIconAlt(hResInst, IDI_HTML_PARAMETER));
 
 			return 0;
Index: trunk/ab5.0/abdev/abdev/DialogBoxes.cpp
===================================================================
--- trunk/ab5.0/abdev/abdev/DialogBoxes.cpp	(revision 825)
+++ trunk/ab5.0/abdev/abdev/DialogBoxes.cpp	(revision 828)
@@ -502,24 +502,24 @@
 void DlgNewProjectWizard(HWND hwnd){
 #define MAX_NEWPROJECTPAGE 3
-	PROPSHEETHEADER psh;
-	PROPSHEETPAGE psp;
-	HPROPSHEETPAGE hpsp[MAX_NEWPROJECTPAGE];
+	PROPSHEETHEADER psh = {};
+	PROPSHEETPAGE psp = {};
+	HPROPSHEETPAGE hpsp[MAX_NEWPROJECTPAGE] = {};
 	int i;
 
-	psp.dwSize=sizeof(PROPSHEETPAGE);
-	psp.hInstance=hResInst;
-	psp.dwFlags=PSP_DEFAULT;
+	psp.dwSize = sizeof(PROPSHEETPAGE);
+	psp.hInstance = GetWindowInstance(hwnd);
+	psp.dwFlags = PSP_DLGINDIRECT;
 
 	//各ページのセッティング
 	i=0;
-	psp.pszTemplate=MAKEINTRESOURCE(IDD_NEWPROJECT_PAGE1);
+	psp.pResource = static_cast<PROPSHEETPAGE_RESOURCE>(ActiveBasic::Resource::LoadResourceAlt(hResInst, IDD_NEWPROJECT_PAGE1, RT_DIALOG));
 	psp.pfnDlgProc=DlgNewProject_Page1;
 	hpsp[i]=CreatePropertySheetPage(&psp);
 	i++;
-	psp.pszTemplate=MAKEINTRESOURCE(IDD_NEWPROJECT_PAGE2);
+	psp.pResource = static_cast<PROPSHEETPAGE_RESOURCE>(ActiveBasic::Resource::LoadResourceAlt(hResInst, IDD_NEWPROJECT_PAGE2, RT_DIALOG));
 	psp.pfnDlgProc=DlgNewProject_Page2;
 	hpsp[i]=CreatePropertySheetPage(&psp);
 	i++;
-	psp.pszTemplate=MAKEINTRESOURCE(IDD_NEWPROJECT_PAGE3);
+	psp.pResource = static_cast<PROPSHEETPAGE_RESOURCE>(ActiveBasic::Resource::LoadResourceAlt(hResInst, IDD_NEWPROJECT_PAGE3, RT_DIALOG));
 	psp.pfnDlgProc=DlgNewProject_Page3;
 	hpsp[i]=CreatePropertySheetPage(&psp);
@@ -630,8 +630,8 @@
 			ImageList_AddIcon(hImageList, LoadIcon(hInst, MAKEINTRESOURCE(IDI_FILE_BAS)));
 			ImageList_AddIcon(hImageList, LoadIcon(hInst, MAKEINTRESOURCE(IDI_FILE_SBP)));
-			ImageList_AddIcon(hImageList, LoadIcon(hResInst, MAKEINTRESOURCE(IDI_NEWFILE_PJ)));
-			ImageList_AddIcon(hImageList, LoadIcon(hResInst, MAKEINTRESOURCE(IDI_NEWFILE_TEXT)));
-			ImageList_AddIcon(hImageList, LoadIcon(hResInst, MAKEINTRESOURCE(IDI_NEWFILE_HTML)));
-			ImageList_AddIcon(hImageList, LoadIcon(hResInst, MAKEINTRESOURCE(IDI_NEWFILE_ICON)));
+			ImageList_AddIcon(hImageList, ActiveBasic::Resource::LoadIconAlt(hResInst, IDI_NEWFILE_PJ));
+			ImageList_AddIcon(hImageList, ActiveBasic::Resource::LoadIconAlt(hResInst, IDI_NEWFILE_TEXT));
+			ImageList_AddIcon(hImageList, ActiveBasic::Resource::LoadIconAlt(hResInst, IDI_NEWFILE_HTML));
+			ImageList_AddIcon(hImageList, ActiveBasic::Resource::LoadIconAlt(hResInst, IDI_NEWFILE_ICON));
 
 
@@ -947,5 +947,5 @@
 			switch(LOWORD(wParam)){
 				case IDC_DIR:
-					extern LPSTR ExeFileFilter;
+					extern const LPCSTR ExeFileFilter;
 					if(!GetFilePathDialog(hwnd,temporary,ExeFileFilter,"DLLデバッグ用の実行可能ファイルを指定してください",1)) break;
 
@@ -967,7 +967,7 @@
 }
 void DlgProjectOptionSetting(HWND hwnd){
-	PROPSHEETHEADER psh;
-	PROPSHEETPAGE psp[MAX_PJSETDLG];
-	HPROPSHEETPAGE hpsp[MAX_PJSETDLG];
+	PROPSHEETHEADER psh = {};
+	PROPSHEETPAGE psp[MAX_PJSETDLG] = {};
+	HPROPSHEETPAGE hpsp[MAX_PJSETDLG] = {};
 	int i;
 	memset(&SetSwitch,0,MAX_PJSETDLG);
@@ -976,29 +976,29 @@
 	i=0;
 	psp[i].dwSize=sizeof(PROPSHEETPAGE);
-	psp[i].dwFlags=PSP_DEFAULT;
-	psp[i].hInstance=hResInst;
-	psp[i].pszTemplate=MAKEINTRESOURCE(IDD_PJ_OPTION1);
-	psp[i].pfnDlgProc=(DLGPROC)DlgProjectOption_Whole;
+	psp[i].dwFlags = PSP_DLGINDIRECT;
+	psp[i].hInstance = GetWindowInstance(hwnd);
+	psp[i].pResource = static_cast<PROPSHEETPAGE_RESOURCE>(ActiveBasic::Resource::LoadResourceAlt(hResInst, IDD_PJ_OPTION1, RT_DIALOG));
+	psp[i].pfnDlgProc = DlgProjectOption_Whole;
 	hpsp[i]=CreatePropertySheetPage(&psp[i]);
 	i++;
 	psp[i].dwSize=sizeof(PROPSHEETPAGE);
-	psp[i].dwFlags=PSP_DEFAULT;
-	psp[i].hInstance=hResInst;
-	psp[i].pszTemplate=MAKEINTRESOURCE(IDD_PJ_OPTION2);
-	psp[i].pfnDlgProc=(DLGPROC)DlgProjectOption_Win32API;
+	psp[i].dwFlags=PSP_DLGINDIRECT;
+	psp[i].hInstance = GetWindowInstance(hwnd);
+	psp[i].pResource = static_cast<PROPSHEETPAGE_RESOURCE>(ActiveBasic::Resource::LoadResourceAlt(hResInst, IDD_PJ_OPTION2, RT_DIALOG));
+	psp[i].pfnDlgProc = DlgProjectOption_Win32API;
 	hpsp[i]=CreatePropertySheetPage(&psp[i]);
 	i++;
 	psp[i].dwSize=sizeof(PROPSHEETPAGE);
-	psp[i].dwFlags=PSP_DEFAULT;
-	psp[i].hInstance=hResInst;
-	psp[i].pszTemplate=MAKEINTRESOURCE(IDD_PJ_OPTION3);
-	psp[i].pfnDlgProc=(DLGPROC)DlgProjectOption_Manifest;
+	psp[i].dwFlags = PSP_DLGINDIRECT;
+	psp[i].hInstance = GetWindowInstance(hwnd);
+	psp[i].pResource = static_cast<PROPSHEETPAGE_RESOURCE>(ActiveBasic::Resource::LoadResourceAlt(hResInst, IDD_PJ_OPTION3, RT_DIALOG));
+	psp[i].pfnDlgProc = DlgProjectOption_Manifest;
 	hpsp[i]=CreatePropertySheetPage(&psp[i]);
 	i++;
 	psp[i].dwSize=sizeof(PROPSHEETPAGE);
-	psp[i].dwFlags=PSP_DEFAULT;
-	psp[i].hInstance=hResInst;
-	psp[i].pszTemplate=MAKEINTRESOURCE(IDD_PJ_OPTION4);
-	psp[i].pfnDlgProc=(DLGPROC)DlgProjectOption_Debug;
+	psp[i].dwFlags = PSP_DLGINDIRECT;
+	psp[i].hInstance = GetWindowInstance(hwnd);
+	psp[i].pResource = static_cast<PROPSHEETPAGE_RESOURCE>(ActiveBasic::Resource::LoadResourceAlt(hResInst, IDD_PJ_OPTION4, RT_DIALOG));
+	psp[i].pfnDlgProc = DlgProjectOption_Debug;
 	hpsp[i]=CreatePropertySheetPage(&psp[i]);
 
@@ -1955,9 +1955,17 @@
 	return 0;
 }
+PROPSHEETPAGE_RESOURCE LoadTest(HINSTANCE hinst, USHORT id, LPCTSTR type)
+{
+	auto t = ActiveBasic::Resource::LoadResourceAltWithSize(hResInst, id, type);
+	auto p = malloc(t.second);
+	memcpy(p, t.first, t.second);
+	return static_cast<PROPSHEETPAGE_RESOURCE>(p);
+}
 void DlgOptionSetting(HWND hwnd){
-	PROPSHEETHEADER psh;
+	HINSTANCE hinst = GetWindowInstance(hwnd);
+	PROPSHEETHEADER psh = {};
 #define MAX_SETDLG 32
-	PROPSHEETPAGE psp[MAX_SETDLG];
-	HPROPSHEETPAGE hpsp[MAX_SETDLG];
+	PROPSHEETPAGE psp[MAX_SETDLG] = {};
+	HPROPSHEETPAGE hpsp[MAX_SETDLG] = {};
 	int i;
 
@@ -1970,31 +1978,32 @@
 	i=0;
 
+
 	//各ページのセッティング
 	psp[i].dwSize=sizeof(PROPSHEETPAGE);
-	psp[i].dwFlags=PSP_DEFAULT;
-	psp[i].hInstance=hResInst;
-	psp[i].pszTemplate=MAKEINTRESOURCE(IDD_OPTION_WHOLE);
-	psp[i].pfnDlgProc=(DLGPROC)Dlg_Option_Whole;
+	psp[i].dwFlags=PSP_DLGINDIRECT;
+	psp[i].hInstance=hinst;
+	psp[i].pResource = static_cast<PROPSHEETPAGE_RESOURCE>(LoadTest(hResInst, IDD_OPTION_WHOLE, RT_DIALOG));
+	psp[i].pfnDlgProc=Dlg_Option_Whole;
 	hpsp[i]=CreatePropertySheetPage(&psp[i]);
 	i++;
 	psp[i].dwSize=sizeof(PROPSHEETPAGE);
-	psp[i].dwFlags=PSP_DEFAULT;
-	psp[i].hInstance=hResInst;
-	psp[i].pszTemplate=MAKEINTRESOURCE(IDD_OPTION_EDITOR);
-	psp[i].pfnDlgProc=(DLGPROC)Dlg_Option_Editor;
+	psp[i].dwFlags=PSP_DLGINDIRECT;
+	psp[i].hInstance=hinst;
+	psp[i].pResource = static_cast<PROPSHEETPAGE_RESOURCE>(LoadTest(hResInst, IDD_OPTION_EDITOR, RT_DIALOG));
+	psp[i].pfnDlgProc=Dlg_Option_Editor;
 	hpsp[i]=CreatePropertySheetPage(&psp[i]);
 	i++;
 	psp[i].dwSize=sizeof(PROPSHEETPAGE);
-	psp[i].dwFlags=PSP_DEFAULT;
-	psp[i].hInstance=hResInst;
-	psp[i].pszTemplate=MAKEINTRESOURCE(IDD_OPTION_COLOR);
-	psp[i].pfnDlgProc=(DLGPROC)Dlg_Option_Color;
+	psp[i].dwFlags=PSP_DLGINDIRECT;
+	psp[i].hInstance=hinst;
+	psp[i].pResource = static_cast<PROPSHEETPAGE_RESOURCE>(LoadTest(hResInst, IDD_OPTION_COLOR, RT_DIALOG));
+	psp[i].pfnDlgProc=Dlg_Option_Color;
 	hpsp[i]=CreatePropertySheetPage(&psp[i]);
 	i++;
 	psp[i].dwSize=sizeof(PROPSHEETPAGE);
-	psp[i].dwFlags=PSP_DEFAULT;
-	psp[i].hInstance=hResInst;
-	psp[i].pszTemplate=MAKEINTRESOURCE(IDD_OPTION_TOOLBAR);
-	psp[i].pfnDlgProc=(DLGPROC)Dlg_Option_Toolbar;
+	psp[i].dwFlags=PSP_DLGINDIRECT;
+	psp[i].hInstance=hinst;
+	psp[i].pResource = static_cast<PROPSHEETPAGE_RESOURCE>(LoadTest(hResInst, IDD_OPTION_TOOLBAR, RT_DIALOG));
+	psp[i].pfnDlgProc=Dlg_Option_Toolbar;
 	hpsp[i]=CreatePropertySheetPage(&psp[i]);
 
@@ -2003,8 +2012,8 @@
 	i++;
 	psp[i].dwSize=sizeof(PROPSHEETPAGE);
-	psp[i].dwFlags=PSP_DEFAULT;
-	psp[i].hInstance=hResInst;
-	psp[i].pszTemplate=MAKEINTRESOURCE(IDD_OPTION_RAD);
-	psp[i].pfnDlgProc=(DLGPROC)Dlg_Option_Rad;
+	psp[i].dwFlags=PSP_DLGINDIRECT;
+	psp[i].hInstance=hinst;
+	psp[i].pResource = static_cast<PROPSHEETPAGE_RESOURCE>(LoadTest(hResInst, IDD_OPTION_RAD, RT_DIALOG));
+	psp[i].pfnDlgProc=Dlg_Option_Rad;
 	hpsp[i]=CreatePropertySheetPage(&psp[i]);
 #endif
@@ -2039,6 +2048,9 @@
 #ifndef THETEXT
 		//ライブラリ開発チーム
-		LoadString(hResInst,IDS_DEV_GROUP,temporary,1024);
-		SetDlgItemText(hwnd,IDC_DEV_GROUP,temporary);
+		boost::optional<std::wstring> devGroup = ActiveBasic::Resource::LoadStringAlt(hResInst, IDS_DEV_GROUP);
+		if (devGroup)
+		{
+			SetDlgItemTextW(hwnd, IDC_DEV_GROUP, devGroup->c_str());
+		}
 #endif
 		ApplyDialogTexture(hwnd);
Index: trunk/ab5.0/abdev/abdev/DrawBuffer.cpp
===================================================================
--- trunk/ab5.0/abdev/abdev/DrawBuffer.cpp	(revision 825)
+++ trunk/ab5.0/abdev/abdev/DrawBuffer.cpp	(revision 828)
@@ -222,7 +222,6 @@
 
 				if(bBreakPoint){
-					DrawIconEx(memdc,3,i*font_height+(font_height-16)/2,
-						(HICON)LoadImage(hIconResInst,MAKEINTRESOURCE(IDI_BREAKPOINT_FLAG),IMAGE_ICON,16,16,LR_SHARED),
-						16,16,0,NULL,DI_NORMAL);
+					ActiveBasic::Resource::UniqueHIcon hicon(ActiveBasic::Resource::LoadIconAlt(hIconResInst, IDI_BREAKPOINT_FLAG, 16, 16));
+					DrawIconEx(memdc,3,i*font_height+(font_height-16)/2,hicon.get(),16,16,0,NULL,DI_NORMAL);
 				}
 				else{
@@ -272,4 +271,16 @@
 	}
 };
+
+static bool IsRemoteSession()
+{
+	OSVERSIONINFO vi = {sizeof vi};
+	BOOL ret = ::GetVersionEx(&vi);
+	if (ret && vi.dwMajorVersion >= 5)
+	{
+		const int SM_REMOTESESSION = 0x1000;
+		return GetSystemMetrics(SM_REMOTESESSION);
+	}
+	return false;
+}
 
 void TextEdit_DrawBuffer(HDC hdc,int WndNum,bool drawDirectly){
@@ -307,5 +318,5 @@
 		OnePage_CharHeight,
 		iLineNumberTextCount,
-		drawDirectly || GetSystemMetrics(SM_REMOTESESSION));
+		drawDirectly || IsRemoteSession());
 
 
Index: trunk/ab5.0/abdev/abdev/ExtensionLink.cpp
===================================================================
--- trunk/ab5.0/abdev/abdev/ExtensionLink.cpp	(revision 825)
+++ trunk/ab5.0/abdev/abdev/ExtensionLink.cpp	(revision 828)
@@ -430,5 +430,8 @@
 			switch(LOWORD(wParam)){
 				case IDC_ADD_BUTTON:
-					if(!DialogBoxParam(hResInst,MAKEINTRESOURCE(IDD_EXTENSION_ADD),hwnd,(DLGPROC)DlgFileLinkAdd,0)) return 1;
+					if (!ActiveBasic::Resource::DialogBoxAlt(hResInst, IDD_EXTENSION_ADD, hwnd, DlgFileLinkAdd))
+					{
+						return 1;
+					}
 
 					pobj_nv->pobj_ExtLink->ResetListView(GetDlgItem(hwnd,IDC_EXTENSION_LIST));
@@ -445,5 +448,8 @@
 					if(i==ListView_GetItemCount(hListView)) return 1;
 
-					if(!DialogBoxParam(hResInst,MAKEINTRESOURCE(IDD_EXTENSION_ADD),hwnd,(DLGPROC)DlgFileLinkAdd,(LPARAM)pobj_nv->pobj_ExtLink->ppobj_ExtItems[i])) return 1;
+					if (!ActiveBasic::Resource::DialogBoxAlt(hResInst, IDD_EXTENSION_ADD, hwnd, DlgFileLinkAdd,(LPARAM)pobj_nv->pobj_ExtLink->ppobj_ExtItems[i]))
+					{
+						return 1;
+					}
 
 					pobj_nv->pobj_ExtLink->ResetListView(GetDlgItem(hwnd,IDC_EXTENSION_LIST));
@@ -516,5 +522,8 @@
 	pobj_nv->save();
 
-	if(DialogBox(hResInst,MAKEINTRESOURCE(IDD_EXTENSION_LINK),hwnd,(DLGPROC)DlgLinkFile)==0) return;
+	if (ActiveBasic::Resource::DialogBoxAlt(hResInst, IDD_EXTENSION_LINK, hwnd, DlgLinkFile)==0)
+	{
+		return;
+	}
 
 	char szApplicationPath[MAX_PATH];
Index: trunk/ab5.0/abdev/abdev/FileOperation.cpp
===================================================================
--- trunk/ab5.0/abdev/abdev/FileOperation.cpp	(revision 825)
+++ trunk/ab5.0/abdev/abdev/FileOperation.cpp	(revision 828)
@@ -190,5 +190,5 @@
 }
 
-BOOL GetFilePathDialog(HWND hwnd,char *filename,LPSTR Filter,LPSTR Title,_int8 IsOpen){
+BOOL GetFilePathDialog(HWND hwnd,char *filename,LPCSTR Filter,LPCSTR Title,BOOL IsOpen){
 	OPENFILENAME ofstr;
 	filename[0]=0;
@@ -345,5 +345,5 @@
 BOOL SaveDocument(HWND hChild,char *SaveFileName){	//ウィンドウからバッファを読み取り、ファイルに保存
 	//SaveFileNameがNULLのときは上書き保存を試みる。
-	extern LPSTR IconFileFilter;
+	extern const LPCSTR IconFileFilter;
 	extern HWND hClient,hDocCombo;
 	int WndNum,i2;
@@ -415,9 +415,9 @@
 get_file_path:
 
-				LPSTR ff;
-
-				extern LPSTR DefFileFilter;
-				extern LPSTR HtmlFileFilter;
-				extern LPSTR TextFileFilter;
+				LPCSTR ff;
+
+				extern const LPCSTR DefFileFilter;
+				extern const LPCSTR HtmlFileFilter;
+				extern const LPCSTR TextFileFilter;
 				if(MdiInfo[WndNum]->DocType==WNDTYPE_BASIC)
 					ff=DefFileFilter;
Index: trunk/ab5.0/abdev/abdev/FileTree.cpp
===================================================================
--- trunk/ab5.0/abdev/abdev/FileTree.cpp	(revision 825)
+++ trunk/ab5.0/abdev/abdev/FileTree.cpp	(revision 828)
@@ -98,5 +98,5 @@
 				case IDM_FILETREE_INSERT:
 					//"プロジェクトへ挿入するファイルを指定して下さい"
-					extern LPSTR DefFileFilter;
+					extern const LPCSTR DefFileFilter;
 					if(!GetFilePathDialog(hOwner,temporary,DefFileFilter,STRING_FILEOPENTITLE_INSERTEDPROJECT,1)) break;
 					Project_File_Insert(temporary);
@@ -124,5 +124,5 @@
 					break;
 				case IDM_FILETREE_PROPERTY:
-					DialogBox(hResInst,MAKEINTRESOURCE(IDD_PROJECT_FILEPROPERTY),hOwner,(DLGPROC)DlgProject_FileProperty);
+					ActiveBasic::Resource::DialogBoxAlt(hResInst, IDD_PROJECT_FILEPROPERTY, hOwner, DlgProject_FileProperty);
 					break;
 			}
@@ -160,7 +160,7 @@
 	//イメージリスト読み込み、設定
 	hImageList=ImageList_Create(16,16,ILC_COLOR24|ILC_MASK,3,0);
-	ImageList_AddIcon(hImageList,LoadIcon(hResInst,MAKEINTRESOURCE(IDI_FOLDER_CLOSE)));
-	ImageList_AddIcon(hImageList,LoadIcon(hResInst,MAKEINTRESOURCE(IDI_FOLDER_OPEN)));
-	ImageList_AddIcon(hImageList,LoadIcon(hResInst,MAKEINTRESOURCE(IDI_TEXTDOCUMENT)));
+	ImageList_AddIcon(hImageList, ActiveBasic::Resource::LoadIconAlt(hResInst, IDI_FOLDER_CLOSE));
+	ImageList_AddIcon(hImageList, ActiveBasic::Resource::LoadIconAlt(hResInst, IDI_FOLDER_OPEN));
+	ImageList_AddIcon(hImageList, ActiveBasic::Resource::LoadIconAlt(hResInst, IDI_TEXTDOCUMENT));
 	this->SetImageList(hImageList,TVSIL_NORMAL);
 }
Index: trunk/ab5.0/abdev/abdev/IconEditor.cpp
===================================================================
--- trunk/ab5.0/abdev/abdev/IconEditor.cpp	(revision 825)
+++ trunk/ab5.0/abdev/abdev/IconEditor.cpp	(revision 828)
@@ -360,13 +360,13 @@
 	//ツールダイアログ部分を作成
 	HWND hToolDlg;
-	hToolDlg=CreateDialog(hResInst,MAKEINTRESOURCE(IDD_ICONEDIT_TOOL),hChild,(DLGPROC)DlgIconToolProc);
+	hToolDlg=ActiveBasic::Resource::CreateDialogAlt(hResInst, IDD_ICONEDIT_TOOL, hChild, DlgIconToolProc);
 
 	//ツールダイアログのボタン部分を作成
 	HWND hButtonsDlg;
-	hButtonsDlg=CreateDialog(hResInst,MAKEINTRESOURCE(IDD_ICONEDIT_BUTTONS),hToolDlg,(DLGPROC)DlgIconButtons);
+	hButtonsDlg=ActiveBasic::Resource::CreateDialogAlt(hResInst, IDD_ICONEDIT_BUTTONS, hToolDlg, DlgIconButtons);
 
 	//カラーテーブルダイアログ部分を作成
 	HWND hColorDlg;
-	hColorDlg=CreateDialog(hResInst,MAKEINTRESOURCE(IDD_ICONEDIT_COLOR),hChild,(DLGPROC)DlgIconColorProc);
+	hColorDlg=ActiveBasic::Resource::CreateDialogAlt(hResInst, IDD_ICONEDIT_COLOR, hChild, DlgIconColorProc);
 
 	//ウィンドウのID登録
Index: trunk/ab5.0/abdev/abdev/IconEditor_Main.cpp
===================================================================
--- trunk/ab5.0/abdev/abdev/IconEditor_Main.cpp	(revision 825)
+++ trunk/ab5.0/abdev/abdev/IconEditor_Main.cpp	(revision 828)
@@ -1199,5 +1199,5 @@
 				InvalidateRect(hwnd,NULL,0);
 
-				SetCursor(LoadCursor(hResInst,MAKEINTRESOURCE(IDC_CURSOR_PEN)));
+				SetCursor(ActiveBasic::Resource::LoadCursorAlt(hResInst, IDC_CURSOR_PEN));
 			}
 			else if(MdiInfo[WndNum]->MdiIconEditInfo->NowTool==IDC_TOOL_FILL){
@@ -1214,5 +1214,5 @@
 					InvalidateRect(hwnd,NULL,0);
 				}
-				SetCursor(LoadCursor(hResInst,MAKEINTRESOURCE(IDC_CURSOR_FILL)));
+				SetCursor(ActiveBasic::Resource::LoadCursorAlt(hResInst, IDC_CURSOR_FILL));
 			}
 			else if(MdiInfo[WndNum]->MdiIconEditInfo->NowTool==IDC_TOOL_LINE||
@@ -1496,7 +1496,7 @@
 				}
 				else if(MdiInfo[WndNum]->MdiIconEditInfo->NowTool==IDC_TOOL_PEN)
-					SetCursor(LoadCursor(hResInst,MAKEINTRESOURCE(IDC_CURSOR_PEN)));
+					SetCursor(ActiveBasic::Resource::LoadCursorAlt(hResInst, IDC_CURSOR_PEN));
 				else if(MdiInfo[WndNum]->MdiIconEditInfo->NowTool==IDC_TOOL_FILL)
-					SetCursor(LoadCursor(hResInst,MAKEINTRESOURCE(IDC_CURSOR_FILL)));
+					SetCursor(ActiveBasic::Resource::LoadCursorAlt(hResInst, IDC_CURSOR_FILL));
 				else if(MdiInfo[WndNum]->MdiIconEditInfo->NowTool==IDC_TOOL_LINE||
 					MdiInfo[WndNum]->MdiIconEditInfo->NowTool==IDC_TOOL_RECTANGLE||
Index: trunk/ab5.0/abdev/abdev/IconEditor_Tool.cpp
===================================================================
--- trunk/ab5.0/abdev/abdev/IconEditor_Tool.cpp	(revision 825)
+++ trunk/ab5.0/abdev/abdev/IconEditor_Tool.cpp	(revision 828)
@@ -55,7 +55,9 @@
 
 			hToolBar=CreateToolbarEx(hwnd,WS_CHILD|WS_VISIBLE|CCS_NODIVIDER|TBSTYLE_FLAT|TBSTYLE_TOOLTIPS,
-				NULL,
+				0,
 				BMPNUM_ICONTOOLBAR,	/*ビットマップの個数*/
-				hResInst,(unsigned int)MAKEINTRESOURCE(IDR_ICONTOOLBAR),IconToolBar,
+				nullptr,
+				reinterpret_cast<UINT_PTR>(ActiveBasic::Resource::LoadBitmapAlt(hResInst, IDR_ICONTOOLBAR)),
+				IconToolBar,
 				BMPNUM_ICONTOOLBAR,	/*アイテムの個数*/
 				0,0,16,15,sizeof(TBBUTTON));
@@ -188,5 +190,5 @@
 			switch(LOWORD(wParam)){
 				case IDC_ADD_ICONTYPE:
-					i=DialogBox(hResInst,MAKEINTRESOURCE(IDD_ICONEDIT_ICONTYPE),GetParent(hwnd),DlgIconType);
+					i = ActiveBasic::Resource::DialogBoxAlt(hResInst, IDD_ICONEDIT_ICONTYPE, GetParent(hwnd), DlgIconType);
 					if(i==-1) return 1;
 
Index: trunk/ab5.0/abdev/abdev/MenuProc.cpp
===================================================================
--- trunk/ab5.0/abdev/abdev/MenuProc.cpp	(revision 825)
+++ trunk/ab5.0/abdev/abdev/MenuProc.cpp	(revision 828)
@@ -73,5 +73,8 @@
 	MENU_INFO *MenuInfo;
 
-	if(!DialogBoxParam(hResInst,MAKEINTRESOURCE(IDD_INPUTID),hOwner,(DLGPROC)DlgProject_MenuID_Input,0)) return;
+	if (!ActiveBasic::Resource::DialogBoxAlt(hResInst, IDD_INPUTID, hOwner, DlgProject_MenuID_Input))
+	{
+		return;
+	}
 
 	//重複チェック
@@ -265,5 +268,5 @@
 
 	MdiInfo[i]->MdiMenuInfo->hMenuEdit=hMenuEdit;
-	MdiInfo[i]->MdiMenuInfo->hEdit_Dlg=CreateDialog(hResInst,MAKEINTRESOURCE(IDD_PROJECT_MENUEDIT),hMenuEdit,(DLGPROC)MenuEditDlg);
+	MdiInfo[i]->MdiMenuInfo->hEdit_Dlg = ActiveBasic::Resource::CreateDialogAlt(hResInst, IDD_PROJECT_MENUEDIT, hMenuEdit, MenuEditDlg);
 
 	SCROLLINFO ScrollInfo;
@@ -406,5 +409,8 @@
 					pMenuInfo=&pMenuInfo->pMenuInfo[i2];
 
-					if(!DialogBoxParam(hResInst,MAKEINTRESOURCE(IDD_PROJECT_MENURENAME),hOwner,(DLGPROC)DlgMenuProperty_Rename,(long)pMenuInfo)) return 1;
+					if (!ActiveBasic::Resource::DialogBoxAlt(hResInst, IDD_PROJECT_MENURENAME, hOwner, DlgMenuProperty_Rename, reinterpret_cast<LPARAM>(pMenuInfo)))
+					{
+						return 1;
+					}
 					GetDlgItemText(hwnd,IDC_IDNAME,temporary,MAX_PATH);
 
Index: trunk/ab5.0/abdev/abdev/NonVolatile.h
===================================================================
--- trunk/ab5.0/abdev/abdev/NonVolatile.h	(revision 825)
+++ trunk/ab5.0/abdev/abdev/NonVolatile.h	(revision 828)
@@ -1,5 +1,6 @@
 
 
-class CNonVolatile:public CSettingFile{
+class CNonVolatile : public CSettingFile, boost::noncopyable
+{
 	void InitToDefaultData();
 
Index: trunk/ab5.0/abdev/abdev/ParameterHint.cpp
===================================================================
--- trunk/ab5.0/abdev/abdev/ParameterHint.cpp	(revision 825)
+++ trunk/ab5.0/abdev/abdev/ParameterHint.cpp	(revision 828)
@@ -1096,5 +1096,5 @@
 			HBITMAP hBmp,hOldBmp;
 			HDC memdc;
-			hBmp=(HBITMAP)LoadImage(hResInst,MAKEINTRESOURCE(IDB_PARAMHINT_QUESTION),IMAGE_BITMAP,0,0,LR_DEFAULTSIZE);
+			hBmp = ActiveBasic::Resource::LoadBitmapAlt(hResInst, IDB_PARAMHINT_QUESTION);
 			memdc=CreateCompatibleDC(hdc);
 			hOldBmp=(HBITMAP)SelectObject(memdc,hBmp);
@@ -1119,5 +1119,5 @@
 				hdc=GetDC(hwnd);
 
-				hBmp=(HBITMAP)LoadImage(hResInst,MAKEINTRESOURCE(IDB_PARAMHINT_QUESTION2),IMAGE_BITMAP,0,0,LR_DEFAULTSIZE);
+				hBmp = ActiveBasic::Resource::LoadBitmapAlt(hResInst,IDB_PARAMHINT_QUESTION2);
 				memdc=CreateCompatibleDC(hdc);
 				hOldBmp=(HBITMAP)SelectObject(memdc,hBmp);
@@ -1137,5 +1137,5 @@
 				hdc=GetDC(hwnd);
 
-				hBmp=(HBITMAP)LoadImage(hResInst,MAKEINTRESOURCE(IDB_PARAMHINT_QUESTION),IMAGE_BITMAP,0,0,LR_DEFAULTSIZE);
+				hBmp = ActiveBasic::Resource::LoadBitmapAlt(hResInst, IDB_PARAMHINT_QUESTION);
 				memdc=CreateCompatibleDC(hdc);
 				hOldBmp=(HBITMAP)SelectObject(memdc,hBmp);
Index: trunk/ab5.0/abdev/abdev/Print.cpp
===================================================================
--- trunk/ab5.0/abdev/abdev/Print.cpp	(revision 825)
+++ trunk/ab5.0/abdev/abdev/Print.cpp	(revision 828)
@@ -421,7 +421,7 @@
 			//拡大・縮小アイコンを表示
 			SendDlgItemMessage(hwnd,IDC_ZOOMOUT,BM_SETIMAGE,IMAGE_ICON ,
-				(LPARAM)LoadImage(hResInst,MAKEINTRESOURCE(IDI_ZOOMOUT),IMAGE_ICON,16,16,LR_SHARED));
+				reinterpret_cast<LPARAM>(ActiveBasic::Resource::LoadIconAlt(hResInst, IDI_ZOOMOUT, 16, 16, LR_SHARED)));
 			SendDlgItemMessage(hwnd,IDC_ZOOMIN,BM_SETIMAGE,IMAGE_ICON ,
-				(LPARAM)LoadImage(hResInst,MAKEINTRESOURCE(IDI_ZOOMIN),IMAGE_ICON,16,16,LR_SHARED));
+				reinterpret_cast<LPARAM>(ActiveBasic::Resource::LoadIconAlt(hResInst, IDI_ZOOMIN, 16, 16, LR_SHARED)));
 			iZoomNowPage=ZOOM_INIT;
 
@@ -522,5 +522,5 @@
 
 void Preview(void){
-	DialogBox(hResInst,MAKEINTRESOURCE(IDD_PREVIEW),hOwner,DlgPreview);
+	ActiveBasic::Resource::DialogBoxAlt(hResInst, IDD_PREVIEW, hOwner, DlgPreview);
 }
 
